/*
  Copyright 2006 Patrik Nilsson and Daniel Nilsson

  This file is part of shpirn.
  
  shpirn is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
	
  shpirn is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with shpirn; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "shpirn.h"

Client *first_client = NULL;
Client *last_client = NULL;

Client * add_client( int fd )
{
   Client *client;

   client = (Client *) malloc( sizeof( Client ) );
   if( !client )
   {
      fprintf( stderr, "malloc failed\n" );
      exit( EXIT_FAILURE );
   }
   memset( client, 0, sizeof( Client ) );
   if( first_client )
   {
      last_client->next = client;
      client->prev = last_client;
      last_client = client;
   }
   else
      first_client = last_client = client;
   client->fd = fd;
   return client;
}

void del_client( Client *client )
{
   if( client->prev )
   {
      if( client->next )
      {
         client->prev->next = client->next;
         client->next->prev = client->prev;
      }
      else
      {
         client->prev->next = NULL;
         last_client = client->prev;
      }
   }
   else
   {
      if( client->next )
      {
         client->next->prev = NULL;
         first_client = client->next;
      }
      else
         first_client = last_client = NULL;
   }

   /* shutdown the network connection */
   if( client->fd )
      close( client->fd );

   free( client );
}

