/*
  Copyright 2006 Patrik Nilsson and Daniel Nilsson

  This file is part of shpirn.
  
  shpirn is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
	
  shpirn is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with shpirn; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* lpio.c:
   Handels the I/O related to lpt. */

#include <stdio.h>
#include <sys/io.h>

#include "shpirn.h"
#include "lpio.h"

int lpio_prepare( void )
{
  /* prepares the lpt */
  if( ioperm( BASE, 3, 1 ))
  {
    fprintf( stderr, "Error: cant access 0x%x...\n", BASE );
	return FALSE;
  }
  return TRUE;
}

int lpio_read( int pin )
{
  /* returns status for the pin */
  int pins[8];
  int inp, x;

  inp = inb( BASE +1 );

  for( x = 0; x < 8; x++ )
  {
	pins[x] = inp & (1<<x) ? 0 : 1; /* magic... */
  }
  return pins[pin];
}

int lpio_write( int pin, int value )
{
  /* sets pin to value
	 returns true on success */

  printf( "lpio.c: lpio_write not implented!\n" );
  return FALSE;
}
