/*
  Copyright 2006 Patrik Nilsson and Daniel Nilsson

  This file is part of shpirn.
  
  shpirn is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
	
  shpirn is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with shpirn; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef __SHPIRN_H
#define __SHPIRN_H

#define TRUE 1
#define FALSE 0
#define VERSION "0.0.1"
#ifndef DEBUG
#define CPS 500
#else
#define CPS 1
#endif
#define NETPORT 9800
#define MSG_LEN 1024

/* shpirn.c */
void test_io( void );
int real_loop( void );
void sock_send( int fd, char *fmt, ... );

/* logger.c */
int logger_init( const char *file );
void logger_write( char *fmt, ... );
void logger_close();

/* lists.c */
struct Client {
   int fd;
   struct Client *next, *prev;
};
typedef struct Client Client;

extern Client *first_client, *last_client;

Client * add_client( int fd );
void del_client( Client *client );

#define foreach_client( x ) for( x = first_client; x; x = x->next )

#endif /* __SHPIRN_H */
